/*****************************************************************************/
/*                                                                           */
/*   File and Shared-Memory Control Program         Version 1.1.0            */
/*                     for Linux-2.2.19 (slockware)                          */
/*                                                                           */
/*                                by  Naohito Iwasa                          */
/*                                                                           */
/*****************************************************************************/
/*   Note for using Shared memory                                            */
/*    % ipcs  :  show shared memory,                                         */
/*    % ipcs shm XXXX  :  remove shared memory                               */
/*                                                                           */
/*****************************************************************************/
#include <fcntl.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <stdio.h>
#include <time.h>

#include "camac.h"
#include "blocker.h"

struct SHM_CC7700 *shmp;
int CC7700_fd=0;
unsigned short int *buffer;
char header[BLOCK_LENGTH*2];
int shmid;

void open_buffer();
void close_buffer();
char *time2asc(long time);
char *date2asc(long time);

#ifdef ANAPAW
#define SHMKEY_ANAPAW 17001
#define SEMKEY_ANAPAW 18001

int shmid_anapaw, semid_anapaw;
char *shmp_anapaw;
union semun{
  int val;
  struct semid_ds *buf;
  unsigned short *array;
  struct seminfo *__buf;
};
struct sembuf semb_anapaw;
union semun semunion;
#endif


int main()
{
  int  i,j,k,pos;
  unsigned short s,t;
  unsigned char c=0,d=0;
  DCCycle dcc;
  char start_time[10],stop_time[10],present_date[10];

  if((CC7700_fd = open("/dev/PCIcc7700", O_RDWR))<=0){
    puts("BLOCKER: device driver is not installed");
    return(-1);
  }
  if ((shmid = shmget(SHMKEY, sizeof(struct SHM_CC7700), 0600)) != -1){
    shmp = (struct SHM_CC7700 *)shmat(shmid, 0, 0);
    if(shmp->status!=0)ioctl(CC7700_fd, DC_INTOFF, 0);
    shmp->status=0; shmp->raw_fd=0; 
  }
  else if ((shmid = shmget(SHMKEY, sizeof(struct SHM_CC7700), IPC_CREAT|0600)) 
	   != -1){
    shmp = (struct SHM_CC7700 *)shmat(shmid, 0, 0);
    
    for(i=0;i<BLOCK_LENGTH*2;i++)header[i]=0;
    shmp->runno=0; shmp->status=0; 
    shmp->block_no=0; shmp->event_no=0; 
    shmp->raw_filename[0]=0;
    shmp->start_time=0;  shmp->stop_time=0;
    shmp->scaler_max=-1;
    for(i=0;i<MAX_BLOCK;i++) {
      shmp->buffer[i].status;
      shmp->buffer[i].blockno;
    }
    shmp->com_flag=0;
    shmp->com_time=0;
    shmp->com_filename[0]=0;
    for(i=0;i<10;i++)shmp->scalers[i]=0;
    shmp->pid=0;
  }
  else {
    puts("DMA_CONT: Cannot create shared memory"); 
    exit(2);
  }
  
#ifdef ANAPAW
  if ((shmid_anapaw = shmget(SHMKEY_ANAPAW, BLOCK_LENGTH*sizeof(short)+4, 
			     IPC_CREAT|0777)) == -1){
    perror("Cannot create shared memory for ANAPAW.\n");
    exit(1);
  }
  shmp_anapaw = shmat(shmid_anapaw, 0, 0);

  if ((semid_anapaw = semget(SEMKEY_ANAPAW, 1, IPC_CREAT|0666)) == -1){
    perror("Cannot create semaphore for ANAPAW.\n");
    shmdt(shmp_anapaw);
    shmctl(shmid_anapaw,IPC_RMID,0);
    exit(1);
  }
  semunion.val=1;
  if(semctl(semid_anapaw,0,SETVAL,semunion)==-1){
    perror("Cannot control semaphore for ANAPAW.\n");
    shmdt(shmp_anapaw);
    shmctl(shmid_anapaw,IPC_RMID,0);
    semctl(semid_anapaw,0,IPC_RMID,semunion);
    exit(1);
  }

#endif

  shmp->pid=getpid();

  
  open_buffer();

  
  while ((k=read(CC7700_fd, &s , sizeof(short))) != -1) {
    if(k<1)continue;
    /*    printf("\n%x ",s);*/
    if(s!=DELIM){
      printf("illegal deliminer (pos=%d) 0x%x (should be 0x%x)\n",buffer[3],s,DELIM);
      continue;
    }
    if(read(CC7700_fd, &s , sizeof(short)) == -1) break;
    /*    printf("%x ",s);*/

  L1:
    if (s<2048){       /* ordinary raw data */
      if(header[0]==1&&shmp->raw_fd!=0){
	if(shmp->stop_time>0){
	  strcpy(start_time  ,time2asc(shmp->start_time));
	  strcpy(stop_time   ,time2asc(shmp->stop_time));
	  strcpy(present_date,date2asc(shmp->stop_time));
	  sprintf(&header[0x14],
		  "RUN-%04d  START => %s  STOP => %s  PRINT => --:--:--  %s",
		  shmp->runno,start_time,stop_time,present_date);
	}
	else{
	  strcpy(start_time  ,time2asc(shmp->start_time));
	  strcpy(stop_time   ,"--:--:--");
	  strcpy(present_date,date2asc(shmp->start_time));
	  sprintf(&header[0x14],
		  "RUN-%04d  START => %s  STOP => %s  PRINT => --:--:--  %s",
		  shmp->runno,start_time,stop_time,present_date);
	}
	strcpy(&header[0x64],shmp->com_comments);
	write(shmp->raw_fd,header,BLOCK_LENGTH*sizeof(short));
	header[0]=0;
      }
/*      if(buffer[3]+s >= BLOCK_LENGTH-(shmp->scaler_max)*12-1){*/
      if(buffer[3]+s >= BLOCK_LENGTH-(shmp->scaler_max)*24-4){
	close_buffer();
	open_buffer();
      }
      pos=buffer[3];
      shmp->event_no++;
      buffer[1]++;
      buffer[pos] = 0x8000+s;
      read(CC7700_fd,&(buffer[pos+1]),sizeof(short)*(s-1));
      /*      for(k=1;k<s;k++)
	printf("%04x ",buffer[pos+k]);
      */
      /*
	 printf("%d\t",pos);
	 printf("%d:",buffer[pos]);
	 for(i=1;i<buffer[pos];i++)printf("%x ",buffer[pos+i]);
	 printf("\n");
	 */
      buffer[3]+=s;
    }
    else if (s == 0xfffc) {  /* start acquisition */
/*      puts("start acquisition");*/
      shmp->status=1;
      shmp->start_time=shmp->com_time;
      shmp->stop_time=0;
      shmp->com_flag=0;
    }
    else if (s == 0xfffd) {  /* stop acquisition */
/*      puts("stop acquisition");*/
      shmp->status=0;
      shmp->stop_time=shmp->com_time;
      shmp->com_flag=0;
    }
    else if (s == 0xfffb) {  /* clear buffer */
      shmp->block_no=0; shmp->event_no=0; 
      shmp->raw_filename[0]=0;
      shmp->start_time=0;  shmp->stop_time=0;
      for(i=0;i<MAX_BLOCK;i++) {
	shmp->buffer[i].status;
	shmp->buffer[i].blockno;
	for(j=0;j<BLOCK_LENGTH;j++)shmp->buffer[i].data[j]=0;
      }
      shmp->com_time=0;
      for(i=0;i<shmp->scaler_max;i++){
	dcc.n=shmp->scalers[i];
	dcc.f=9;
	dcc.a=0;
	ioctl(CC7700_fd, DC_CYCLE, &dcc);
      }
      shmp->com_flag=0;
      open_buffer();
    }
    else if (s == 0xfffe) {  /* open file */
/*      puts("open file");*/
      if(shmp->com_flag==0){
	sprintf(shmp->com_message,
		"                                fatal error in illegal file-open procedure!!");
	continue;
      }
      close_buffer();
      if(shmp->raw_fd>0){
	header[0]=2;header[1]=0;
	if(shmp->stop_time>0){
	  strcpy(start_time  ,time2asc(shmp->start_time));
	  strcpy(stop_time   ,time2asc(shmp->stop_time));
	  strcpy(present_date,date2asc(shmp->stop_time));
	  sprintf(&header[0x14],
		  "RUN-%04d  START => %s  STOP => %s  PRINT => --:--:--  %s",
		  shmp->runno-1,start_time,stop_time,present_date);
	}
	else{
	  strcpy(start_time  ,time2asc(shmp->start_time));
	  strcpy(stop_time   ,"--:--:--");
	  strcpy(present_date,date2asc(shmp->start_time));
	  sprintf(&header[0x14],
		  "RUN-%04d  START => %s  STOP => %s  PRINT => --:--:--  %s",
		  shmp->runno-1,start_time,stop_time,present_date);
	}
	strcpy(&header[0x64],shmp->com_comments);
	write(shmp->raw_fd,header,BLOCK_LENGTH*sizeof(short));
	close(shmp->raw_fd); 
	shmp->raw_fd=0;
      }
      header[0]=1;header[1]=0;
      if(strncmp(shmp->com_filename,"/dev/",5)==0)
	sprintf(shmp->raw_filename,"%s",shmp->com_filename);
      else
	sprintf(shmp->raw_filename,"%s.%03d",shmp->com_filename,shmp->runno);
      if((shmp->raw_fd=open(shmp->raw_filename,O_WRONLY|O_CREAT, 0644))<=0){
	sprintf(shmp->com_message,
		"                                                   the file cannot be opened");
	shmp->raw_fd=0;
      }
      else{
	shmp->com_message[0]=0;
	shmp->start_time=shmp->stop_time=0;
	shmp->block_no=0; shmp->event_no=0; 
	for(i=0;i<MAX_BLOCK;i++) {
	  shmp->buffer[i].status;
	  shmp->buffer[i].blockno;
	  for(j=0;j<BLOCK_LENGTH;j++)shmp->buffer[i].data[j]=0;
	}
	shmp->com_time=0;
      }
      shmp->com_flag=0;
      open_buffer();
    }
    else if (s == 0xffff) {  /* End of file */
/*      puts("close file");*/
      if(shmp->com_flag==0){
	sprintf(shmp->com_message,
		"                                   fatal error in the file-close procedure!!");
	continue;
      } 
      if(header[0]!=1)close_buffer();
      if(shmp->raw_fd>0){
	if(header[0]==1){
	  if(shmp->stop_time>0){
	    strcpy(start_time  ,time2asc(shmp->start_time));
	    strcpy(stop_time   ,time2asc(shmp->stop_time));
	    strcpy(present_date,date2asc(shmp->stop_time));
	    sprintf(&header[0x14],
		    "RUN-%04d  START => %s  STOP => %s  PRINT => --:--:--  %s",
		    shmp->runno,start_time,stop_time,present_date);
	  }
	  else{
	    strcpy(start_time  ,time2asc(shmp->start_time));
	    strcpy(stop_time   ,"--:--:--");
	    strcpy(present_date,date2asc(shmp->start_time));
	    sprintf(&header[0x14],
		    "RUN-%04d  START => %s  STOP => %s  PRINT => --:--:--  %s",
		    shmp->runno,start_time,stop_time,present_date);
	  }
	  strcpy(&header[0x64],shmp->com_comments);
	  write(shmp->raw_fd,header,BLOCK_LENGTH*sizeof(short));
	  header[0]=0;
	}
	header[0]=2;header[1]=0;
	if(shmp->stop_time>0){
	  strcpy(start_time  ,time2asc(shmp->start_time));
	  strcpy(stop_time   ,time2asc(shmp->stop_time));
	  strcpy(present_date,date2asc(shmp->stop_time));
	  sprintf(&header[0x14],
		  "RUN-%04d  START => %s  STOP => %s  PRINT => --:--:--  %s",
		  shmp->runno,start_time,stop_time,present_date);
	}
	else{
	  strcpy(start_time  ,time2asc(shmp->start_time));
	  strcpy(stop_time   ,"--:--:--");
	  strcpy(present_date,date2asc(shmp->start_time));
	  sprintf(&header[0x14],
		  "RUN-%04d  START => %s  STOP => %s  PRINT => --:--:--  %s",
		  shmp->runno,start_time,stop_time,present_date);
	}
	strcpy(&header[0x64],shmp->com_comments);
	write(shmp->raw_fd,header,BLOCK_LENGTH*sizeof(short));
	close(shmp->raw_fd); 
	shmp->raw_fd = 0;
      }
      shmp->com_flag=0;
      open_buffer();
    }
  }    
}


void open_buffer()
{
  buffer=shmp->buffer[shmp->block_no%MAX_BLOCK].data;
  shmp->buffer[shmp->block_no%MAX_BLOCK].status=BLOCK_WRITING;
  shmp->buffer[shmp->block_no%MAX_BLOCK].blockno=(++shmp->block_no);
  buffer[0]=0;
  buffer[1]=0;
  buffer[2]=BLOCK_LENGTH;
  buffer[3]=4;
}
void close_buffer()
{
  int i,j;
  DCCycle dcc;

  buffer[buffer[3]]=0xffff;
  buffer[buffer[3]+1]=0xffff;

  ioctl(CC7700_fd, DC_I, 1);
  for(i=0;i<shmp->scaler_max;i++){
    dcc.n=shmp->scalers[i];
    dcc.f=0;
    for(j=0;j<12;j++){
      dcc.a=j;
      ioctl(CC7700_fd, DC_CYCLE, &dcc);
      buffer[BLOCK_LENGTH+(i-shmp->scaler_max)*24+j*2]=dcc.data&0xffff;
      buffer[BLOCK_LENGTH+(i-shmp->scaler_max)*24+j*2+1]=dcc.data>>16;
      shmp->scaler_data[i][j]+=dcc.data;
    }
    dcc.f=9;
    ioctl(CC7700_fd, DC_CYCLE, &dcc);
  }
  ioctl(CC7700_fd, DC_I, 0);
  ioctl(CC7700_fd, DC_INTACT, 0);

  shmp->buffer[shmp->block_no%MAX_BLOCK].status=BLOCK_WAITING;
  if(shmp->raw_fd>0)
    if(write(shmp->raw_fd,(char *)buffer,BLOCK_LENGTH*sizeof(short))<=0){
      sprintf(shmp->com_message,"                         Acquisition was stopped due to lack of disk space !!");
      printf("Acquisition was stopped due to lack of disk space !!\n");
      close(shmp->raw_fd);
      shmp->raw_fd = 0;
      if(shmp->status!=0)ioctl(CC7700_fd, DC_INTOFF, 0);
      time(&shmp->stop_time);
    }
#ifdef ANAPAW
  /*void semaphore_p_anapaw(void)*/
  {  semb_anapaw.sem_op=-1; semop(semid_anapaw,&semb_anapaw,1); }
  memcpy(shmp_anapaw,(char *)buffer,BLOCK_LENGTH*sizeof(short));
  memcpy(shmp_anapaw+BLOCK_LENGTH*sizeof(short),&(shmp->block_no),4);
  /*void semaphore_v_anapaw(void)*/
  {  semb_anapaw.sem_op=1;  semop(semid_anapaw,&semb_anapaw,1); }
#endif
}
char *time2asc(long time)
{
  static char str[40];
  struct tm *t;
  if(time==0)strcpy(str,"--:--:--");
  else{
    t=localtime(&time);
    sprintf(str,"%02d:%02d:%02d\0",t->tm_hour,t->tm_min,t->tm_sec);
  }
  return(str);
}
char *date2asc(long time)
{
  static char str[40];
  struct tm *t;
  char *month[12]={
    "JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"};
  if(time==0)strcpy(str,"--------");
  else{
    t=localtime(&time);
    sprintf(str,"%02d-%s-%02d\0",
	    t->tm_mday,month[t->tm_mon],t->tm_year%100);
  }
  return(str);
}

