/*****************************************************************************/
/*                                                                           */
/*   File and Shared-Memory Control Program         Version 1.0.0            */
/*                     for Linux-2.0.31 (slockware)                          */
/*                                                                           */
/*         Produced on 3 Dec 1997 by  Naohito Iwasa                          */
/*                                                                           */
/*****************************************************************************/
#include <sys/wait.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdio.h>
#include <signal.h>
#include <time.h>
#include "blocker.h"

struct SHM_CC7700 *shmp;
int CC7700_fd=0;
unsigned char header[BLOCK_LENGTH*2];
int shmid;

char *time2asc(time_t time)
{
  static char str[40];
  struct tm *t;
  if(time==0)strcpy(str,"--:--:--");
  else{
    t=localtime(&time);
    sprintf(str,"%02d:%02d:%02d\0",t->tm_hour,t->tm_min,t->tm_sec);
  }
  return(str);
}

char *date2asc(time_t time)
{
  static char str[40];
  struct tm *t;
  char *month[12]={
    "JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"};
  if(time==0)strcpy(str,"--------");
  else{
    t=localtime(&time);
    sprintf(str,"%02d-%s-%02d\0",
            t->tm_mday,month[t->tm_mon],t->tm_year%100);
  }
  return(str);
}
void f()
{}
int main()
{
  int  i,pos;
  time_t current;
  char line[80];

  if ((shmid = shmget(SHMKEY, sizeof(struct SHM_CC7700), 0600)) 
      == -1)
    {puts("STATUS: Cannot create shared memory"); exit(2);}
  shmp = (struct SHM_CC7700 *)shmat(shmid, 0, 0);

  while(1){
    printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
    time(&current);
    if(shmp->status==0){
      printf("\33[1;1H Run-%04d   Start = %s  ",
	     shmp->runno, time2asc(shmp->start_time));
      printf("Stop = %s  ",time2asc(shmp->stop_time));
      printf("Current= %s  %s\n",time2asc(current),date2asc(current));
    }
    else{
      printf("\33[1;1H Run-%04d   Start = %s  ***ACQUIRING***  ",
	     shmp->runno, time2asc(shmp->start_time));
      printf("Current= %s  %s\n",time2asc(current),date2asc(current));
    }
    printf("%s\n",shmp->com_message);
    if(shmp->raw_fd==0)
      printf(" HEADER: %s\n\n",shmp->com_filename);
    else
      printf(" FILE:%s opened\n\n",shmp->raw_filename);

    printf(" BLOCK No =%10d       SCALERS [%d]:",
	   shmp->block_no,shmp->scaler_max);
    for(i=0;i<shmp->scaler_max;i++)
      printf("%2d ",shmp->scalers[i]);
    printf("\n");
    printf(" EVENT No =%10d       ",shmp->event_no);
    if(shmp->raw_fd>0)
      printf("FILE SIZE =%8.1f MByte\n",(shmp->block_no+2)*16384e-6);
    else
      printf("\n");
    
    printf("\nBLK1 ");
    for(i=1;i<32;i++)printf("%4x ",shmp->buffer[0].data[i]);
    printf("\nBLK2 ");
    for(i=1;i<32;i++)printf("%4x ",shmp->buffer[1].data[i]);
    printf("\nBLK3 ");
    for(i=1;i<32;i++)printf("%4x ",shmp->buffer[2].data[i]);
    printf("\nBLK4 ");
    for(i=1;i<32;i++)printf("%4x ",shmp->buffer[3].data[i]);
    printf("\nBLK5 ");
    for(i=1;i<32;i++)printf("%4x ",shmp->buffer[4].data[i]);
    printf("\nBLK6 ");
    for(i=1;i<32;i++)printf("%4x ",shmp->buffer[5].data[i]);
    printf("\nBLK7 ");
    for(i=1;i<32;i++)printf("%4x ",shmp->buffer[6].data[i]);
    printf("\nBLK8 ");
    for(i=1;i<32;i++)printf("%4x ",shmp->buffer[7].data[i]);
    printf("\n");
    signal(SIGALRM,f);
    alarm(2);
    pause();
  }
}
